#ifndef _CONFIG_H
#define _CONFIG_H

#define F_OSC		F_CPU

// SHT11 hum/temp sensor
#define SHT11_PORT	D
#define SHT11_SCL	(1<<PD4)
#define SHT11_SDA	(1<<PD7)
#define SHT11_LOWRES	1		// 0: 12/14bit (SHT11), 1: 8/12bit (SHT11+FOST02)

/*****************************************************************************/

#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

typedef uint8_t	uword_t; // most efficient machine word, 8bit min.
typedef int8_t	sword_t;

#define GLUE(a, b)	a##b
#define PORT(x)		GLUE(PORT, x)
#define PIN(x)		GLUE(PIN, x)
#define DDR(x)		GLUE(DDR, x)

#define setBits(port,mask)	do{ (port) |=  (mask); }while(0)
#define clrBits(port,mask)	do{ (port) &= ~(mask); }while(0)
#define tstBits(port,mask)	((port) & (mask))

/*****************************************************************************/
#if DEBUG
  #include <stdio.h>
  #define PRINTF(s, ...) { static char __s[] PROGMEM = (s); \
			   printf_P(__s, ## __VA_ARGS__); }
#else
  #define PRINTF(s, ...)
#endif
/*****************************************************************************/

#endif //_CONFIG_H
